package esercitazione4.pileecode;

public class MyQueue<T> implements IQueue<T> {

	private T[] items;
	private int maxLength;
	private int head;
	private int size;
	
	public MyQueue(int c) {
		this.items = (T[]) new Object[c];
		this.head = 0;
		this.size = 0;
	}

	@Override
	public boolean isEmpty() {
		return (this.size == 0);
	}
	

	@Override
	public void enqueue(T item) {
		if (this.size < this.items.length) {
			this.items[(this.head + this.size) % this.items.length] = item;
			this.size++;
		}
	}

	@Override
	public T dequeue() {
		
		T tmp = null;
		
		if (!this.isEmpty()) {
			tmp = this.items[head];
			this.head = (this.head + 1) % this.items.length;
			this.size--;
		}
		
		return tmp;
	}

	@Override
	public T top() {
		T tmp = null;
		
		if (!this.isEmpty())
			tmp = this.items[head];
		
		return tmp;
	}

	@Override
	public String toString() {
		return java.util.Arrays.toString(this.items);
	}

	
	
}
