package esercitazione4.pileecode;

import esercitazione3.lists.MyNode;

public class Stack<T> implements IStack<T> {

	private StackItem<T> testa;	
	
	@Override
	public boolean isEmpty() {
		return (this.testa == null);
	}

	@Override
	public void push(T item) {
		
		StackItem<T> tmp = new StackItem(item, this.testa);
		this.testa = tmp;
	}

	@Override
	public T pop() {
	
		T tmp = null;
		
		if (!this.isEmpty()) {
			tmp = this.testa.getItem();
			this.testa = this.testa.getNext();
		}
		
		return tmp;
	}

	@Override
	public T top() {
		
		if (this.isEmpty())
			return null;
		else
			return this.testa.getItem();
	}

	@Override
	public String toString() {
		String s = "";
		StackItem<T> tmp = this.testa;
		
		while (tmp != null) {
			s = s + " - " + tmp.getItem().toString();
			tmp = tmp.getNext();
		}
		
		return s;
	}

	
	
	
}
